#include "dem.h"
#include "integral.h"
#include <cstdio>
#include "lapacke.h"

#ifdef __cplusplus
extern "C"
{
#endif
#include <cblas.h>
#ifdef __cplusplus
}
#endif

void calc_PandG2(double &P11,double &P33,double &P44,double &P12,double &P13,const double c11,const double c33,const double c44,const double c12,const double c13,const double a){
//This program is called from dem_aniso and sca_aniso. Input stiffness
//elements are in Voigt notation. If you have them in Kelvin's notation then
//divide your c44 by 2 before calling this program. Returned P matrix is in
//Kelvin's notation. 
//Computes Gijkl and Pijkl for VTI medium
//Kaushik Bandyopadhyay Feb 07, 2008
// apect aratio = a(1)/a(3)

 double d=c11,e=0.5*(c11-c12),f=c44,g=c13+c44,h=c33;

 auto g1111=[a,d,e,f,g,h](double x)->double{return 0.5*pi*(1./((e*(1.-x*x)+f*a*a*x*x)*((d*(1.-x*x)+f*a*a*x*x)*(f*(1.-x*x)+h*a*a*x*x)-g*g*a*a*x*x*(1.-x*x))))*(1.-x*x)*((f*(1.-x*x)+h*a*a*x*x)*((3.*e+d)*(1.-x*x)+4.*f*a*a*x*x)-g*g*a*a*x*x*(1.-x*x));};
 double G1111=GaussLobattoInt(g1111,0.,1.);
 //G2222=G1111;
 
 auto g3333=[a,d,e,f,g,h](double x)->double{return 4.*pi*(1./((e*(1.-x*x)+f*a*a*x*x)*((d*(1.-x*x)+f*a*a*x*x)*(f*(1.-x*x)+h*a*a*x*x)-g*g*a*a*x*x*(1.-x*x))))*a*a*x*x*(d*(1.-x*x)+f*a*a*x*x)*(e*(1.-x*x)+f*a*a*x*x);};
 double G3333=GaussLobattoInt(g3333,0.,1.);

 auto g1122=[a,d,e,f,g,h](double x)->double{return 0.5*pi*(1./((e*(1.-x*x)+f*a*a*x*x)*((d*(1.-x*x)+f*a*a*x*x)*(f*(1.-x*x)+h*a*a*x*x)-g*g*a*a*x*x*(1.-x*x))))*(1.-x*x)*((f*(1.-x*x)+h*a*a*x*x)*((e+3.*d)*(1.-x*x)+4.*f*a*a*x*x)-3.*g*g*a*a*x*x*(1.-x*x));};
 double G1122=GaussLobattoInt(g1122,0.,1.);
 //G2211=G1122;

 auto g1133=[a,d,e,f,g,h](double x)->double{return 2.*pi*(1./((e*(1.-x*x)+f*a*a*x*x)*((d*(1.-x*x)+f*a*a*x*x)*(f*(1.-x*x)+h*a*a*x*x)-g*g*a*a*x*x*(1.-x*x))))*a*a*x*x*(((d+e)*(1.-x*x)+2.*f*a*a*x*x)*(f*(1.-x*x)+h*a*a*x*x)-g*g*a*a*x*x*(1.-x*x));};
 double G1133=GaussLobattoInt(g1133,0.,1.);
 //G2233=G1133;

 auto g3311=[a,d,e,f,g,h](double x)->double{return 2.*pi*(1./((e*(1.-x*x)+f*a*a*x*x)*((d*(1.-x*x)+f*a*a*x*x)*(f*(1.-x*x)+h*a*a*x*x)-g*g*a*a*x*x*(1.-x*x))))*(1.-x*x)*(d*(1.-x*x)+f*a*a*x*x)*(e*(1.-x*x)+f*a*a*x*x);};
 double G3311=GaussLobattoInt(g3311,0.,1.);
 //G3322=G3311;

 auto g1212=[a,d,e,f,g,h](double x)->double{return 0.5*pi*(1./((e*(1.-x*x)+f*a*a*x*x)*((d*(1.-x*x)+f*a*a*x*x)*(f*(1.-x*x)+h*a*a*x*x)-g*g*a*a*x*x*(1.-x*x))))*((1.-x*x)*(1.-x*x))*(g*g*a*a*x*x-(d-e)*(f*(1.-x*x)+h*a*a*x*x));};
 double G1212=GaussLobattoInt(g1212,0.,1.);

 auto g1313=[a,d,e,f,g,h](double x)->double{return -2.*pi*(1./((e*(1.-x*x)+f*a*a*x*x)*((d*(1.-x*x)+f*a*a*x*x)*(f*(1.-x*x)+h*a*a*x*x)-g*g*a*a*x*x*(1.-x*x))))*g*a*a*x*x*(1.-x*x)*(e*(1.-x*x)+f*a*a*x*x);};
 double G1313=GaussLobattoInt(g1313,0.,1.);
 //G2323=G1313;

//Format G in Kelvin's notation
//G=zeros(6,6);
//G(1,1)=G1111; G(1,2)=G1122; G(1,3)=G1133;
//G(2,1)=G2211; G(2,2)=G2222; G(2,3)=G2233;
//G(3,1)=G3311; G(3,2)=G3322; G(3,3)=G3333;
//G(4,4)=2*G2323; G(5,5)=2*G1313; G(6,6)=2*G1212;


//P1111=(1/(16*pi))*(4*G1111);
//P2222=(1/(16*pi))*(4*G2222);
//P3333=(1/(16*pi))*(4*G3333);
//P1122=(1/(16*pi))*(4*G1212);
//P1133=(1/(16*pi))*(4*G1313);
//P2211=P1122;
//P3311=P1133;
//P2233=(1/(16*pi))*(4*G2323);
//P3322=P2233;
//P2323=(1/(16*pi))*(G2233+2*G2323+G3322);
//P1313=(1/(16*pi))*(G1133+2*G1313+G3311);
//P1212=(1/(16*pi))*(G1122+2*G1212+G2211);

//P=zeros(6,6);
//P(1,1)=P1111; P(1,2)=P1122; P(1,3)=P1133;
//P(2,1)=P2211; P(2,2)=P2222; P(2,3)=P2233;
//P(3,1)=P3311; P(3,2)=P3322; P(3,3)=P3333;
//P(4,4)=2*P2323; P(5,5)=2*P1313; P(6,6)=2*P1212;
//P is in Kelvin's notation
 P11=0.25*G1111/pi;
 P33=0.25*G3333/pi;
 P44=0.125*(G1133+2.*G1313+G3311)/pi;
 P12=0.25*G1212/pi;
 P13=0.25*G1313/pi;
 
 return;
}

void dem_aniso(double &c11,double &c33,double &c44,double &c12,double &c13,
               const double a11,const double a33,const double a44,const double a12,const double a13,
               const double b11,const double b33,const double b44,const double b12,const double b13,
			   const double a,const double phi){
// Kaushik Bandyopadhyay Feb 07, 2008
// Ref: Hornby, Brian E., Larry M. Schwartz, and John A. Hudson. "Anisotropic effective-medium modeling of the elastic properties of shales." Geophysics 59, no. 10 (1994): 1570-1583.

//Initial guess for the effective stiffness
 double a11k=a11,a33k=a33,a44k=2.*a44,a12k=a12,a13k=a13;        
 double b11k=b11,b33k=b33,b44k=2.*b44,b12k=b12,b13k=b13;        
 c11=a11k;c33=a33k;c44=a44k;c12=a12k;c13=a13k;        
 
 double P11=0.,P33=0.,P44=0.,P12=0.,P13=0.;
 
 int INFO=1,N=6,IPIV[6],LWORK=36;
 double WORK[36];

 double dv=phi/NDEM;
 double v=0.;
 
 for(int i=1;i<=NDEM;++i){
  calc_PandG2(P11,P33,P44,P12,P13,c11,c33,0.5*c44,c12,c13,1./a);     
  
  double P[36]={P11,P12,P13,0.,0.,0.,
                P12,P11,P13,0.,0.,0.,
                P13,P13,P33,0.,0.,0.,
                0.,0.,0.,P44,0.,0.,
                0.,0.,0.,0.,P44,0.,
                0.,0.,0.,0.,0.,P11-P12};
  
  double eye[36]={1.,0.,0.,0.,0.,0.,
                  0.,1.,0.,0.,0.,0.,
                  0.,0.,1.,0.,0.,0.,
                  0.,0.,0.,1.,0.,0.,
                  0.,0.,0.,0.,1.,0.,
                  0.,0.,0.,0.,0.,1.};
  
  double temp[36]={b11k-c11,b12k-c12,b13k-c13,0.,0.,0.,
                   b12k-c12,b11k-c11,b13k-c13,0.,0.,0.,
                   b13k-c13,b13k-c13,b33k-c33,0.,0.,0.,
                   0.,0.,0.,b44k-c44,0.,0.,
                   0.,0.,0.,0.,b44k-c44,0.,
                   0.,0.,0.,0.,0.,b11k-b12k-(c11-c12)};
  
  cblas_dgemm(CblasRowMajor,CblasNoTrans,CblasNoTrans,N,N,N,1,P,N,temp,N,1,eye,N);
  
  dgetrf_(&N,&N,eye,&N,IPIV,&INFO);
  dgetri_(&N,eye,&N,IPIV,WORK,&LWORK,&INFO);

  cblas_dgemm(CblasRowMajor,CblasNoTrans,CblasNoTrans,N,N,N,dv/(1.-v),temp,N,eye,N,0,P,N);
  
  c11+=P[0];c33+=P[14];c44+=P[21];c12+=P[1];c13+=P[2];
  
  v+=dv;
 }

 c44*=0.5;
 return;
}
