#include <cmath>
#include "myio.h"
#include "mylib.h"

int main(int argc,char **argv){
 myio_init(argc,argv);
 
 int nx,nz;
 float dx,dz,ox,oz;
 from_header("vshale","n1",nx,"d1",dx,"o1",ox);
 from_header("vshale","n2",nz,"d2",dz,"o2",oz);

 float *poro=new float[nx*nz]();
 float *vshale=new float[nx*nz]();
 read("vshale",vshale,nx*nz);
 float *sandporo=new float[nx*nz]();
 read("sandporo",sandporo,nx*nz);
 float *shaleporo=new float[nx*nz]();
 read("shaleporo",shaleporo,nx*nz);

 float wdepth;
 get_param("wdepth",wdepth);
 int nwdepth=wdepth/dz+1;
 set(poro,1.,nwdepth*nx);

 for(int i=nwdepth*nx;i<nz*nx;++i){
  poro[i]=sandporo[i]*(1.-vshale[i])+shaleporo[i]*vshale[i];
 }

 write("poro",poro,nx*nz);
 to_header("poro","n1",nx,"d1",dx,"o1",ox);
 to_header("poro","n2",nz,"d2",dz,"o2",oz);

 delete []poro;delete []vshale;delete []sandporo;delete []shaleporo;

 myio_close();
 return 0;
}

