#include "myio.h"
#include "mylib.h"

int main(int argc,char **argv){
 myio_init(argc,argv);
 
 int nx,nz;
 float dx,dz,ox,oz;
 get_param("nx",nx,"dx",dx,"ox",ox);
 get_param("nz",nz,"dz",dz,"oz",oz);

 float *vshale=new float[nx*nz]();
 read("vshalein",vshale,nx*nz);

 float wdepth;
 get_param("wdepth",wdepth);
 int nwdepth=wdepth/dz;
 set(vshale,0.,nx*nwdepth);

 #pragma omp parallel for num_threads(16)
 for(int i=nx*nwdepth;i<nx*nz;++i){
  if(vshale[i]>1.) vshale[i]=1.;
 }

 write("vshaleout",vshale,nx*nz);
 to_header("vshaleout","n1",nx,"d1",dx,"o1",ox);
 to_header("vshaleout","n2",nz,"d2",dz,"o2",oz);

 delete []vshale;

 myio_close();
 return 0;
}

