#include <cmath>
#include "myio.h"
#include "mylib.h"

int main(int argc,char **argv){
 myio_init(argc,argv);
 
 int nx,nz;
 float dx,dz,ox,oz;
 get_param("nx",nx,"dx",dx,"ox",ox);
 get_param("nz",nz,"dz",dz,"oz",oz);

 float *poro=new float[nx*nz]();

 float wdepth;
 get_param("wdepth",wdepth);
 int nwdepth=wdepth/dz+1;

 float a=0.2875,b=-0.00774,c=0.4384,d=-0.0001761; 

 for(int i=nwdepth;i<nz;++i){
  float z=(i*dz+oz-wdepth)*3.28084;
  float phi;
  phi=a*exp(b*z)+c*exp(d*z);
  if(phi<0.) phi=0.;
  set(poro+i*nx,phi,nx);
 }

write("poro",poro,nx*nz);
 to_header("poro","n1",nx,"d1",dx,"o1",ox);
 to_header("poro","n2",nz,"d2",dz,"o2",oz);

 delete []poro;

 myio_close();
 return 0;
}

