#include "myio.h"
#include "mylib.h"

int main(int argc,char **argv){
 myio_init(argc,argv);
 
 int nx,nz;
 float dx,dz,ox,oz;
 get_param("nx",nx,"dx",dx,"ox",ox);
 get_param("nz",nz,"dz",dz,"oz",oz);

 float tsurface,tgrad;
 get_param("Tsurface",tsurface);
 get_param("Tgrad",tgrad); // in degree C per foot

 float *tt=new float[nx*nz]();

 for(int i=0;i<nz;++i){
  float t=tsurface+tgrad*i*dz*0.001/0.3048;
  set(tt+i*nx,t,nx);
 }

 write("temp",tt,nx*nz);
 to_header("temp","n1",nx,"d1",dx,"o1",ox);
 to_header("temp","n2",nz,"d2",dz,"o2",oz);

 delete []tt;

 myio_close();
 return 0;
}

